using System;
using System.Drawing;
using System.Drawing.Printing;
using System.Windows.Forms;
using System.Drawing.Imaging;
using Bokai.Barcodes;

namespace Bokai.Barcodes.Sample2
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label label1;
		private Bokai.Barcodes.BarcodeControl barcodeControl1;
		private System.Windows.Forms.ListBox listboxProperties;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.TextBox editData;
		private System.Windows.Forms.TextBox editAddOnData;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.LinkLabel linkFont;
		private System.Windows.Forms.TextBox editFont;
		private System.Windows.Forms.ComboBox comboBarcodeType;
		private System.Windows.Forms.ComboBox comboRotation;
		private System.Windows.Forms.Button buttonPrint;
		private System.Windows.Forms.Button buttonSaveImage;
		private System.Windows.Forms.ComboBox comboOrientation;
		private System.ComponentModel.IContainer components = null;
		private System.Windows.Forms.Label label6;
		private System.Windows.Forms.CheckBox checkHiliteMain;
		private System.Windows.Forms.CheckBox checkHiliteAddOn;
		private System.Windows.Forms.CheckBox checkHiliteWhole;

		private BarcodeDrawFlags _drawFlags = 0;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			int i = 0;
			BarcodeTypeEnumerator e = BarcodeControl.EnumerateBarcodeTypes();
			while (e.MoveNext())
			{
				BarcodeTypeInfo barcodeTypeInfo = (BarcodeTypeInfo) e.Current;
				comboBarcodeType.Items.Add(barcodeTypeInfo);
				if (barcodeTypeInfo.BarcodeType == BarcodeType.CODE39) comboBarcodeType.SelectedIndex = i;
				++i;
			}

			// item index corresponds to actual numeric value of BarcodeOrientation
			comboOrientation.Items.Add("BottomFacing");
			comboOrientation.SelectedIndex = 0;
			comboOrientation.Items.Add("RightFacing");
			comboOrientation.Items.Add("TopFacing");
			comboOrientation.Items.Add("LeftFacing");

			editFont.ForeColor = barcodeControl1.ForeColor;
			editFont.Text = barcodeControl1.Font.Name;

			comboRotation.SelectedIndex = 0;

			_drawFlags = 0;
			BarcodeDrawFlags drawFlagsFromProperties = barcodeControl1.DrawFlagsFromProperties;
			Type type = typeof(BarcodeDrawFlags);
			System.Reflection.FieldInfo[] afi = type.GetFields();
			for (i = 0; i < afi.Length; i++)
			{
				if (afi[i].FieldType != type) continue;

				BarcodeDrawFlags flag = (BarcodeDrawFlags) afi[i].GetValue(null);
				switch (flag)
				{
					case BarcodeDrawFlags.WidthPerModule:
					case BarcodeDrawFlags.NoRestoreGraphicsState:
						break;
					default:
						listboxProperties.Items.Add(flag);
						if ((flag & drawFlagsFromProperties) != 0)
							listboxProperties.SetSelected(listboxProperties.Items.Count - 1, true);
						break;
				}
			}

			barcodeControl1.InvalidDataAction = InvalidDataAction.DisplayInvalid;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.listboxProperties = new System.Windows.Forms.ListBox();
			this.barcodeControl1 = new Bokai.Barcodes.BarcodeControl();
			this.comboOrientation = new System.Windows.Forms.ComboBox();
			this.label1 = new System.Windows.Forms.Label();
			this.buttonPrint = new System.Windows.Forms.Button();
			this.buttonSaveImage = new System.Windows.Forms.Button();
			this.label2 = new System.Windows.Forms.Label();
			this.comboBarcodeType = new System.Windows.Forms.ComboBox();
			this.label3 = new System.Windows.Forms.Label();
			this.label4 = new System.Windows.Forms.Label();
			this.editData = new System.Windows.Forms.TextBox();
			this.editAddOnData = new System.Windows.Forms.TextBox();
			this.label5 = new System.Windows.Forms.Label();
			this.comboRotation = new System.Windows.Forms.ComboBox();
			this.linkFont = new System.Windows.Forms.LinkLabel();
			this.editFont = new System.Windows.Forms.TextBox();
			this.checkHiliteMain = new System.Windows.Forms.CheckBox();
			this.checkHiliteAddOn = new System.Windows.Forms.CheckBox();
			this.checkHiliteWhole = new System.Windows.Forms.CheckBox();
			this.label6 = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// listboxProperties
			// 
			this.listboxProperties.Location = new System.Drawing.Point(304, 48);
			this.listboxProperties.Name = "listboxProperties";
			this.listboxProperties.SelectionMode = System.Windows.Forms.SelectionMode.MultiSimple;
			this.listboxProperties.Size = new System.Drawing.Size(168, 316);
			this.listboxProperties.TabIndex = 0;
			this.listboxProperties.SelectedIndexChanged += new System.EventHandler(this.listboxProperties_SelectedIndexChanged);
			// 
			// barcodeControl1
			// 
			this.barcodeControl1.AddOnCaption = null;
			this.barcodeControl1.AddOnData = null;
			this.barcodeControl1.BackColor = System.Drawing.Color.White;
			this.barcodeControl1.Caption = null;
			this.barcodeControl1.Data = "000000";
			this.barcodeControl1.Font = new System.Drawing.Font("Arial", 9F);
			this.barcodeControl1.ForeColor = System.Drawing.Color.Black;
			this.barcodeControl1.Location = new System.Drawing.Point(32, 88);
			this.barcodeControl1.LowerTopTextBy = 0F;
			this.barcodeControl1.Name = "barcodeControl1";
			this.barcodeControl1.RaiseBottomTextBy = 0F;
			this.barcodeControl1.Size = new System.Drawing.Size(224, 112);
			this.barcodeControl1.TabIndex = 1;
			this.barcodeControl1.Visible = false;
			// 
			// comboOrientation
			// 
			this.comboOrientation.Location = new System.Drawing.Point(80, 320);
			this.comboOrientation.Name = "comboOrientation";
			this.comboOrientation.Size = new System.Drawing.Size(128, 21);
			this.comboOrientation.TabIndex = 2;
			this.comboOrientation.SelectedIndexChanged += new System.EventHandler(this.comboOrientation_SelectedIndexChanged);
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(8, 320);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(64, 16);
			this.label1.TabIndex = 3;
			this.label1.Text = "Orientation:";
			// 
			// buttonPrint
			// 
			this.buttonPrint.Location = new System.Drawing.Point(304, 8);
			this.buttonPrint.Name = "buttonPrint";
			this.buttonPrint.TabIndex = 4;
			this.buttonPrint.Text = "Print...";
			this.buttonPrint.Click += new System.EventHandler(this.buttonPrint_Click);
			// 
			// buttonSaveImage
			// 
			this.buttonSaveImage.Location = new System.Drawing.Point(392, 8);
			this.buttonSaveImage.Name = "buttonSaveImage";
			this.buttonSaveImage.Size = new System.Drawing.Size(88, 23);
			this.buttonSaveImage.TabIndex = 5;
			this.buttonSaveImage.Text = "Save Image...";
			this.buttonSaveImage.Click += new System.EventHandler(this.buttonSaveImage_Click);
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(8, 224);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(80, 16);
			this.label2.TabIndex = 6;
			this.label2.Text = "BarcodeType:";
			// 
			// comboBarcodeType
			// 
			this.comboBarcodeType.Location = new System.Drawing.Point(96, 224);
			this.comboBarcodeType.MaxDropDownItems = 30;
			this.comboBarcodeType.Name = "comboBarcodeType";
			this.comboBarcodeType.Size = new System.Drawing.Size(184, 21);
			this.comboBarcodeType.TabIndex = 7;
			this.comboBarcodeType.SelectedIndexChanged += new System.EventHandler(this.comboBarcodeType_SelectedIndexChanged);
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(8, 288);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(72, 16);
			this.label3.TabIndex = 8;
			this.label3.Text = "AddOnData:";
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(8, 256);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(32, 16);
			this.label4.TabIndex = 9;
			this.label4.Text = "Data:";
			// 
			// editData
			// 
			this.editData.Location = new System.Drawing.Point(48, 256);
			this.editData.Name = "editData";
			this.editData.Size = new System.Drawing.Size(232, 20);
			this.editData.TabIndex = 10;
			this.editData.Text = "";
			this.editData.TextChanged += new System.EventHandler(this.editData_TextChanged);
			// 
			// editAddOnData
			// 
			this.editAddOnData.Location = new System.Drawing.Point(96, 288);
			this.editAddOnData.Name = "editAddOnData";
			this.editAddOnData.Size = new System.Drawing.Size(184, 20);
			this.editAddOnData.TabIndex = 11;
			this.editAddOnData.Text = "";
			this.editAddOnData.TextChanged += new System.EventHandler(this.editAddOnData_TextChanged);
			// 
			// label5
			// 
			this.label5.Location = new System.Drawing.Point(8, 352);
			this.label5.Name = "label5";
			this.label5.Size = new System.Drawing.Size(56, 16);
			this.label5.TabIndex = 12;
			this.label5.Text = "Rotation:";
			// 
			// comboRotation
			// 
			this.comboRotation.Items.AddRange(new object[] {
															   "0",
															   "30",
															   "45",
															   "135",
															   "225",
															   "315"});
			this.comboRotation.Location = new System.Drawing.Point(64, 352);
			this.comboRotation.Name = "comboRotation";
			this.comboRotation.Size = new System.Drawing.Size(64, 21);
			this.comboRotation.TabIndex = 13;
			this.comboRotation.SelectedIndexChanged += new System.EventHandler(this.comboRotation_SelectedIndexChanged);
			// 
			// linkFont
			// 
			this.linkFont.Location = new System.Drawing.Point(144, 352);
			this.linkFont.Name = "linkFont";
			this.linkFont.Size = new System.Drawing.Size(32, 16);
			this.linkFont.TabIndex = 14;
			this.linkFont.TabStop = true;
			this.linkFont.Text = "Font:";
			this.linkFont.LinkClicked += new System.Windows.Forms.LinkLabelLinkClickedEventHandler(this.linkFont_LinkClicked);
			// 
			// editFont
			// 
			this.editFont.ForeColor = System.Drawing.SystemColors.WindowText;
			this.editFont.Location = new System.Drawing.Point(184, 352);
			this.editFont.Name = "editFont";
			this.editFont.ReadOnly = true;
			this.editFont.TabIndex = 15;
			this.editFont.Text = "";
			// 
			// checkHiliteMain
			// 
			this.checkHiliteMain.Location = new System.Drawing.Point(136, 384);
			this.checkHiliteMain.Name = "checkHiliteMain";
			this.checkHiliteMain.Size = new System.Drawing.Size(96, 16);
			this.checkHiliteMain.TabIndex = 16;
			this.checkHiliteMain.Text = "Main Barcode";
			this.checkHiliteMain.CheckedChanged += new System.EventHandler(this.checkHilite_CheckedChanged);
			// 
			// checkHiliteAddOn
			// 
			this.checkHiliteAddOn.Location = new System.Drawing.Point(264, 384);
			this.checkHiliteAddOn.Name = "checkHiliteAddOn";
			this.checkHiliteAddOn.Size = new System.Drawing.Size(64, 16);
			this.checkHiliteAddOn.TabIndex = 17;
			this.checkHiliteAddOn.Text = "Add-On";
			this.checkHiliteAddOn.CheckedChanged += new System.EventHandler(this.checkHilite_CheckedChanged);
			// 
			// checkHiliteWhole
			// 
			this.checkHiliteWhole.Location = new System.Drawing.Point(368, 384);
			this.checkHiliteWhole.Name = "checkHiliteWhole";
			this.checkHiliteWhole.Size = new System.Drawing.Size(56, 16);
			this.checkHiliteWhole.TabIndex = 18;
			this.checkHiliteWhole.Text = "Whole";
			this.checkHiliteWhole.CheckedChanged += new System.EventHandler(this.checkHilite_CheckedChanged);
			// 
			// label6
			// 
			this.label6.Location = new System.Drawing.Point(8, 384);
			this.label6.Name = "label6";
			this.label6.Size = new System.Drawing.Size(112, 16);
			this.label6.TabIndex = 19;
			this.label6.Text = "Highlight Rectangles:";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(488, 405);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.label6,
																		  this.checkHiliteWhole,
																		  this.checkHiliteAddOn,
																		  this.checkHiliteMain,
																		  this.editFont,
																		  this.linkFont,
																		  this.comboRotation,
																		  this.label5,
																		  this.editAddOnData,
																		  this.editData,
																		  this.label4,
																		  this.label3,
																		  this.comboBarcodeType,
																		  this.label2,
																		  this.buttonSaveImage,
																		  this.buttonPrint,
																		  this.label1,
																		  this.comboOrientation,
																		  this.barcodeControl1,
																		  this.listboxProperties});
			this.Name = "Form1";
			this.Text = "Barcode .Net Sample2  -  www.bokai.com";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		// in units of 0.01 inch ("LOENGLISH")
		private RectangleF GetDrawingArea()
		{
			RectangleF rect;
			switch (barcodeControl1.Orientation) 
			{
				case BarcodeOrientation.LeftFacing:
				case BarcodeOrientation.RightFacing:
					rect = new RectangleF(80.0f, 40.0f, 60.0f, 180.0f);
					break;
				case BarcodeOrientation.BottomFacing:
				case BarcodeOrientation.TopFacing:
				default:
					rect = new RectangleF(40.0f, 80.0f, 180.0f, 60.0f);
					break;
			}
			return rect;
		}

		protected override void OnPaint(PaintEventArgs e)
		{
			base.OnPaint(e);
			if (comboRotation.SelectedIndex != 0)
				CustomPaint(e.Graphics, true);
			else
				SimplePaint(e.Graphics, true);
		}

		private void SimplePaint(Graphics g, bool onScreen)
		{
			// unit of measure is LOENGLISH, i.e., 0.01 inch:
			RectangleF rect = GetDrawingArea();

			// draw a blue reference rectangle on screen:
			if (onScreen)
			{
				g.PageUnit = GraphicsUnit.Inch;
				g.PageScale = 0.01f;
				g.DrawRectangle(Pens.Blue, rect.X, rect.Y, rect.Width, rect.Height);
			}

			// draw the barcode:
			// (In case of rotation, BarcodeDrawFlags.NoRestoreGraphicsState will cause to 
			// preserve transformation on Graphics so that we can HiliteRectangles)
			barcodeControl1.Draw(g, rect, GraphicsUnit.Inch, 0.01f, 
				barcodeControl1.Orientation, barcodeControl1.Font, barcodeControl1.ForeColor, 
				barcodeControl1.BackColor, _drawFlags | BarcodeDrawFlags.NoRestoreGraphicsState, null);
			// The above is the most sophiscated version of Draw(), where we pass in DrawFlags that
			// override corresponding properties. Alternatively, we could set properties
			// on barcodeControl1 and then call the below simplified version of Draw():
			// barcodeControl1.Draw(g, rect, GraphicsUnit.Inch, 0.01f, _drawFlags, null);

			if (onScreen) HiliteRectangles(g);
		}

		private void CustomPaint(Graphics g, bool onScreen)
		{
			// unit of measure is LOENGLISH, i.e., 0.01 inch:
			RectangleF rect = GetDrawingArea();

			g.PageUnit = GraphicsUnit.Inch;
			g.PageScale = 0.01f;

			float rotation = Single.Parse((string) comboRotation.SelectedItem);
			PointF rotateAt = new PointF(rect.X + rect.Width / 2, rect.Y + rect.Height / 2);
			System.Drawing.Drawing2D.Matrix matrix = g.Transform;
			if (matrix == null) matrix = new System.Drawing.Drawing2D.Matrix();
			matrix.RotateAt(rotation, rotateAt);
			g.Transform = matrix;

			// draw a blue reference rectangle on screen:
			if (onScreen)
				g.DrawRectangle(Pens.Blue, rect.X, rect.Y, rect.Width, rect.Height);

			// draw the barcode (GraphicsUnit.World: use caller's mapping mode):
			barcodeControl1.Draw(g, rect, GraphicsUnit.World, 1.0f, 
				barcodeControl1.Orientation, barcodeControl1.Font, barcodeControl1.ForeColor, 
				barcodeControl1.BackColor, _drawFlags, null);
			// The above is the most sophiscated version of Draw(), where we pass in DrawFlags that
			// override corresponding properties. Alternatively, we could set properties
			// on barcodeControl1 and then call the below simplified version of Draw():
			// barcodeControl1.Draw(g, rect, GraphicsUnit.Inch, 0.01f, _drawFlags, null);

			if (onScreen) HiliteRectangles(g);
		}

		private void HiliteRectangles(Graphics g)
		{
			if (checkHiliteWhole.Checked) g.DrawRectangle(Pens.Red, barcodeControl1.ActualRectangle.X, barcodeControl1.ActualRectangle.Y, barcodeControl1.ActualRectangle.Width, barcodeControl1.ActualRectangle.Height);
			if (checkHiliteMain.Checked) g.DrawRectangle(Pens.Red, barcodeControl1.ActualMainRectangle.X, barcodeControl1.ActualMainRectangle.Y, barcodeControl1.ActualMainRectangle.Width, barcodeControl1.ActualMainRectangle.Height);
			if (checkHiliteAddOn.Checked) g.DrawRectangle(Pens.Red, barcodeControl1.ActualAddOnRectangle.X, barcodeControl1.ActualAddOnRectangle.Y, barcodeControl1.ActualAddOnRectangle.Width, barcodeControl1.ActualAddOnRectangle.Height);
		}

		private void pd_PrintPage(object sender, PrintPageEventArgs e) 
		{
			if (comboRotation.SelectedIndex != 0)
				CustomPaint(e.Graphics, false);
			else
				SimplePaint(e.Graphics, false);
			e.HasMorePages = false ;
		}

		private void comboOrientation_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			barcodeControl1.Orientation = (BarcodeOrientation) (comboOrientation.SelectedIndex);
			this.Refresh();
		}

		private void linkFont_LinkClicked(object sender, System.Windows.Forms.LinkLabelLinkClickedEventArgs e)
		{
			FontDialog fontDialog = new FontDialog();

			fontDialog.ShowColor = true;
			fontDialog.Font = barcodeControl1.Font;
			fontDialog.Color = barcodeControl1.ForeColor;
			if (fontDialog.ShowDialog() == DialogResult.OK)
			{
				barcodeControl1.Font = fontDialog.Font;
				barcodeControl1.ForeColor = fontDialog.Color;

				editFont.ForeColor = barcodeControl1.ForeColor;
				editFont.Text = barcodeControl1.Font.Name;
				this.Refresh();
			}
		}

		private void listboxProperties_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			_drawFlags = 0;
			ListBox.SelectedObjectCollection items = listboxProperties.SelectedItems;
			for (int i = 0; i < items.Count; i++)
			{
				BarcodeDrawFlags flag = (BarcodeDrawFlags) items[i];
				_drawFlags |= flag;
			}

			this.Refresh();
		}

		private void comboBarcodeType_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			barcodeControl1.BarcodeType = (BarcodeType) (comboBarcodeType.SelectedIndex + 1);

			// for demo purposes, use default data consisting of all 0s
			barcodeControl1.UseDefaultData();
			barcodeControl1.UseDefaultAddOnData();

			editData.Text = barcodeControl1.Data;
			editAddOnData.Text = barcodeControl1.AddOnData;
			if ((barcodeControl1.Characteristics & BarcodeCharacteristics.HasAddOn) != 0)
				this.checkHiliteAddOn.Enabled = true;
			else
			{
				this.checkHiliteAddOn.Enabled = false;
				this.checkHiliteAddOn.Checked = false;
			}

			this.Refresh();
		}

		private void editData_TextChanged(object sender, System.EventArgs e)
		{
			try
			{
				barcodeControl1.Data = editData.Text;
			}
			catch (ArgumentException)
			{
			}
			this.Refresh();
		}

		private void editAddOnData_TextChanged(object sender, System.EventArgs e)
		{
			try
			{
				barcodeControl1.AddOnData = editAddOnData.Text;
			}
			catch (ArgumentException)
			{
			}
			this.Refresh();
		}

		private void comboRotation_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			// Use the Orientation property only if the rotation transform
			// is not in effect, in order not to get confused, even though they CAN 
			// work together
			if (comboRotation.SelectedIndex != 0)
			{
				comboOrientation.SelectedIndex = 0;
				comboOrientation.Enabled = false;
			}
			else
				comboOrientation.Enabled = true;
			this.Refresh();
		}

		private void buttonPrint_Click(object sender, System.EventArgs e)
		{
			PrintDocument pd = new PrintDocument();
			pd.PrintPage += new PrintPageEventHandler(this.pd_PrintPage);

			PrintDialog dlg = new PrintDialog() ;
			dlg.Document = pd;
			DialogResult result = dlg.ShowDialog();

			if (result == DialogResult.OK) 
			{
				pd.Print();
			}
		}

		private void buttonSaveImage_Click(object sender, System.EventArgs e)
		{
			System.IO.Stream myStream;
			SaveFileDialog fileDialog = new SaveFileDialog();

			fileDialog.Filter = "GIF files (*.gif)|*.gif|PNG files (*.png)|*.png|JPEG files (*.jpg;*.jpeg)|*.jpg;*.jpeg|BMP files (*.bmp;*.dib)|*.bmp;*.dib|TIFF files (*.tif)|*.tif";
			fileDialog.FilterIndex = 1;
			fileDialog.FileName = "sample2";
			fileDialog.RestoreDirectory = false;
			ImageFormat[] afmt = { ImageFormat.Gif, ImageFormat.Png, ImageFormat.Jpeg, ImageFormat.Bmp, ImageFormat.Tiff };

			if (fileDialog.ShowDialog() == DialogResult.OK)
			{
				if ((myStream = fileDialog.OpenFile())!= null)
				{
					int barcodeWidth = 1;
					int barcodeHeight = 50;
					barcodeControl1.MakeImage(afmt[fileDialog.FilterIndex - 1], barcodeWidth, barcodeHeight, true, false, null, myStream);
					myStream.Close();
				}
			}
		}

		private void checkHilite_CheckedChanged(object sender, System.EventArgs e)
		{
			this.Refresh();
		}
	}
}
